/*
// This is a basic example to demonstrate how the Speech-To-Text Library 
// can be used. See www.getflourish.com/sst/ for more information on
// available settings.
//
// Florian Schulz 2011, www.getflourish.com
// envoie les réponses sur le bus ivy 
// Philippe Truillet, 17 novembre 2011
// v. 1.1
*/

import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;
import com.getflourish.stt.*;
import com.google.gson.*;

import fr.irit.ihcs.processing.*;
import java.util.Properties;


STT stt;
String result;
PIvy myivy;
String data ="";


void setup ()
{
  // proxy -> utiliser le protocole htts
  Properties systemSettings = System.getProperties();
  systemSettings.put("proxySet", "true");
  systemSettings.put("https.proxyHost", "proxy.irit.fr");
  systemSettings.put("https.proxyPort", "8001");
  // systemSettings.put("https.proxyUser", "someUserName");
  // systemSettings.put("https.proxyPassword", "somePassword");
  
  System.setProperties(systemSettings); 
  
  size(500, 200);
  // Init STT automatically starts listening
  stt = new STT(this);
  stt.enableDebug();
  stt.enableAutoThreshold();
  stt.setLanguage("fr"); 


  myivy = new PIvy(this,"127.255.255.255", 2010, "^sra Command=(.*)");
  
  // Some text to display the result
  textFont(createFont("Arial", 24));
  result = "Parlez maintenant !";
}

void draw ()
{
  background(0);
  text(result, mouseX, mouseY);
  
}

// Method is called if transcription was successfull 
void transcribe (String utterance, float confidence) 
{
  println(utterance);
  if (utterance.equals(""))
  {
    myivy.send("sra Notification=NaS");    
  }
  else
  {
    result = utterance;
    myivy.send("sra Text=" + utterance + " Score=" + confidence);    
  }  
}
public void keyPressed () {
	stt.begin();
}
public void keyReleased () {
	stt.end();
}

// event from ivy
void ivyEvent(PIvy p)
{ 
  data = myivy.data[0];

  // println(data);
  if (data.equals("Quit"))
  {
    exit();
  }
}
